#! /usr/bin/python
#- Plumas e Sardinhas - Paulo Silva - GPL - Aug/Sep'09, PyWeek-9 competition - version: 200909011503

import sys,pygame,math,os,random
from pygame.locals import *
from pygame import mixer
pygame.mixer.init()
pygame.init()

xed=640;yed=480;wdwd=0
screen=pygame.display.set_mode((xed,yed),pygame.FULLSCREEN*(1-wdwd));pygame.mouse.set_visible(False)
background=pygame.Surface((xed,yed*1.5))

title_st="Plumas e Sardinhas (v200909011503)";pygame.display.set_caption(title_st)
paper=0x80868D;ink=0x665544;pen=ink
enmagn=1 #enmagn=1: player attracts sardines

# charset
backgroundtx=pygame.Surface((xed,64))
backgroundtx.fill(paper)
chrall_bm=pygame.image.load("data/charset.png")
def printsbpiciloc(txi,tyi,tinv,tstt_st):
  for ti in range(0,len(tstt_st),1):
    u=ord(tstt_st[ti])
    tux=u%32
    tinv2=(abs(int(tinv)%2))
    tuy=int(u/32)+((4*tinv2)%8)
    backgroundtx.blit(chrall_bm.subsurface(tux*8,tuy*8,8,8),((txi+ti)*8,tyi*8))

# creating sprites from subsurfaces
sprall=pygame.image.load("data/sprites.png");ballrect=sprall.get_rect()
spridshp=[];spridshpr=[]
for i in range (0,4,1):
  for j in range (0,4,1):
    k=j+(i*4)
    spritetmp=sprall.subsurface(((j*64),(i*64),64,64));spriterecttmp=spritetmp.get_rect()
    spridshp.append(spritetmp);spridshpr.append(spriterecttmp)

#some variables and arrays
maxsp=32
xsppos=[0]*maxsp;ysppos=[0]*maxsp;yspdir=[0]*maxsp;spvlue=[0]*maxsp
hitime=0

while 1: #whole loop
  for i in range(0,maxsp,1):
    xsppos[i]=xed+((xed/maxsp)*i);ysppos[i]=(random.randint(0,yed))
    yspdir[i]=((random.randint(0,80))-40)/10;spvlue[i]=1
  oxsp=32;oysp=32;feather=50;tikcr=0;enspd=1;featrn=100
  background.fill(paper);backgroundtx.fill(paper);screen.blit(background,(0,0));pygame.display.flip()
  pygame.time.delay(1000)
  printsbpiciloc(2,0,0," "+title_st.upper()+" ")
  printsbpiciloc(2,1,0," PAULO SILVA, AUG/SEP09, GPL - CODED FOR PYWEEK-9 COMPETITION ")
  printsbpiciloc(2,3,0," PUSH SPACE KEY ")
  screen.blit(background,(0,0));screen.blit(backgroundtx,(0,360))
  pygame.display.flip()
  while 1:
    pygame.time.delay(1000/100);key=pygame.key.get_pressed()
    if key[pygame.K_SPACE]:break
    if key[pygame.K_ESCAPE]:sys.exit()
    for event in pygame.event.get():
      if event.type==pygame.QUIT:sys.exit()
  pygame.draw.rect(background,(ink),(0,yed*.75,xed,yed*1.5));backgroundtx.fill(paper)
  time=0

  while 1: #action loop
    key=pygame.key.get_pressed()
    tikcr+=1
    enspd+=.01
    featrn-=.02
    spdw=4+((feather*12)/100)
    spdf=1+(((100-feather)*8)/100)

    # keyboard  
    if key[pygame.K_RIGHT]:oxsp=oxsp+spdw
    if key[pygame.K_LEFT]:oxsp=oxsp-spdw
    if key[pygame.K_UP]:oysp=oysp-spdw    
    if key[pygame.K_DOWN]:oysp=oysp+spdw  

    oysp+=spdf
    if oysp>400:oysp=400
    if oysp<16 :oysp=16
    if oxsp>600:oxsp=600
    if oxsp<16 :oxsp=16

    for i in range(0,maxsp,1):
      ysppos[i]+=yspdir[i];xsppos[i]-=enspd
      if ysppos[i]>yed:ysppos[i]=0
      if ysppos[i]<0:ysppos[i]=yed
      if xsppos[i]<0:
        xsppos[i]+=xed
        spvlue[i]=1
        ysppos[i]=random.randint(0,yed)
        if random.randint(0,100)>featrn:
          spvlue[i]=2
        yspdir[i]=((random.randint(0,80))-40)/10
        if enmagn==1 and spvlue[i]==2:
          yspdir[i]=    (   (oysp- ((ysppos[i]+yed-oysp)%yed)   )     / ( abs (xed-oxsp)+1.0 )) *enspd

    # collisions
    for i in range(0,maxsp,1):
      if abs(oxsp-xsppos[i])<48 and abs (oysp-(ysppos[i]+yed-oysp)%yed)<48:
        if spvlue[i]==1:
          feather +=1;spvlue[i]=0
        if spvlue[i]==2:
          feather -=1;spvlue[i]=0

    time=int(tikcr/50)
    if feather>100:feather=100
    if feather<0:feather=0

    # printing ingame info
    flashv=0
    if feather<35:flashv=(int(tikcr/8))%2
    printsbpiciloc(2,1,flashv," FEATHERS: "+str(feather)+"% ")
    printsbpiciloc(2,2,0," TIME: "+str(time)+" SEC ")
    printsbpiciloc(2,3,0," HI: "+str(hitime)+" SEC ")

    # blitting
    screen.blit(background,(0,((yed-oysp)/2)-(yed/2)))
    screen.blit(backgroundtx,(0,0))
    for i in range(0,maxsp,1):
      if spvlue[i]<>0:
        screen.blit(spridshp[12+(spvlue[i]-1)],(xsppos[i],(ysppos[i]+yed-oysp)%yed))
    screen.blit(spridshp[tikcr%12],(oxsp,oysp))

    # loop tail
    pygame.display.flip();pygame.time.delay(1000/100)
    for event in pygame.event.get():
      if event.type==pygame.QUIT:sys.exit()
    if key[pygame.K_ESCAPE]:sys.exit()
    if feather <=0:break

  gmovcnt=0;printsbpiciloc(2,5,1," GAME OVER ")
  while gmovcnt<250: #game over loop
    gmovcnt+=1;tikcr+=1
    screen.blit(background,(0,((yed-oysp)/2)-(yed/2)))
    screen.blit(backgroundtx,(0,0))
    screen.blit(spridshp[tikcr%12],(oxsp,oysp))
    pygame.display.flip();pygame.time.delay(1000/100)
    for event in pygame.event.get():
      if event.type==pygame.QUIT:sys.exit()
    if key[pygame.K_ESCAPE]:sys.exit()

  # update hiscore
  if hitime<time:hitime=time

